#!/bin/perl
$ppath = '../lib/pfiles/ZZZ';
$binpath = '../../../bin';
$minlevel = 31;
%levls = (34 => "                            &r   \n                            ~~~~~~~&n", 
	  33 => "                     &y            \n                     ~~~~~~~~~~~~~~~~~~~~~~~&n", 
	  32 => "                     &g            \n                     ~~~~~~~~~~~~~~~~~~~~~~~&n",
	  31 => "                     &b          \n                      ~~~~~~~~~~~~~~~~~~~~~&n");

sub by_level { $players{$b} <=> $players{$a} 
		    or  $a  cmp $b         }

sub write_to_file()
{
 open FILE, ">$_[0]"; 
 print FILE 
"*************************************************************************\n" ,
"*       .     *\n" ,
"*   .        *\n" ,
"*     .        . *\n" ,                                     
"*************************************************************************\n\n";
#       
$cl = $_[2] + 1;

  foreach(@sorted) {
   $name = $_;
   $levl = $players{$name};
   if($levl >= $_[1] && $levl <= $_[2]) {
   if($levl < $cl) {
    $cl--;
    print FILE "\n".$levls{$cl}."\n"; # ,  
   }
   print FILE " " x (32 - length($name) / 2) . "$name\n";
   }          
 }
 close FILE;
}

($wizl, $wizf, $imml, $immf, $pid) = ($ARGV[0], $ARGV[1], $ARGV[2], $ARGV[3], $ARGV[4]);

chdir $ppath;
my @files = <*>;
foreach (@files) {
  open FILE, $_;
  my $cur_name, $cur_lev;
  while(<FILE>) {
   if(m/^name: (.*)/i) {
     $cur_name = $1;
   }
   if(m/^levl: (\d*)/i) {
     $cur_level = $1;
   }
   if(defined($cur_name) && defined ($cur_level) && ($cur_level >= $minlevel)) {
     $players{$cur_name} = $cur_level;
     $cur_level = undef;
     $cur_name = undef;
     last;
   }
  }
  close FILE;
};

@sorted = sort by_level keys %players;

chdir $binpath;


&write_to_file($immf, $imml, $wizl - 1);
&write_to_file($wizf, $wizl, 34);

kill 10, $pid
